/*\
|*| --------------------------------------------------------------------------
|*|     GGI general definitons, structures, etc.
|*| --------------------------------------------------------------------------
|*|
|*|	Copyright (C) 1995 by Andreas Beck [becka@hp.rz.uni-duesseldorf.de]
|*|			  and Steffen Seeger [seeger@physik.tu-chemnitz.de]
|*|
|*|	This program is free software; you can redistribute it and/or modify
|*|	it under the terms of the GNU General Public License as published by
|*|	the Free Software Foundation; either version 2, or (at your option)
|*|	any later version.
|*|
|*|	This program is distributed in the hope that it will be useful,
|*|	but WITHOUT ANY WARRANTY; without even the implied warranty of
|*|	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
|*|	GNU General Public License for more details.
|*|
|*|	You should have received a copy of the GNU General Public License
|*|	along with this program; see the file COPYING.  If not, write to
|*|	the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.
|*|
|*| ---------------------------------------------------------------------------
\*/

#ifndef	_ggi_h
#define	_ggi_h

#include "ggi-version.h"

#if 0
  #define	TRUE	1
  #define	FALSE	0
#endif

#define	GGIVERSION	001

	struct	ggi_range { int min, max; };
	struct	ggi_ratio { int mul, div; };
	struct	ggi_coord { short x, y; };
	struct	ggi_rect  { struct ggi_coord a, b; };
	struct	ggi_color { unsigned char r,g,b; };

	enum ggi_graph_type
	{	GT_TEXT	 =  0,		/* alphanumeric modes		*/
		GT_1BIT	 =  1,		/*  1 bpp graphics		*/
		GT_4BIT	 =  2,		/*  4 bpp graphics		*/
		GT_8BIT	 =  3,		/*  8 bpp graphics		*/
		GT_15BIT =  4,		/* 15 bpp graphics 		*/
		GT_16BIT =  5,		/* 16 bpp graphics		*/
		GT_24BIT =  6,		/* 24 bpp graphics		*/
		GT_32BIT =  7,		/* 24 bpp word aligned  	*/
		GT_LAST  =  8		/* last mode assigned   	*/
	};

	#define	GM_TEXT		(1 << GT_TEXT)
	#define	GM_1BIT		(1 << GT_1BIT)
	#define	GM_4BIT		(1 << GT_4BIT)
	#define	GM_8BIT		(1 << GT_8BIT)
	#define	GM_15BIT	(1 << GT_15BIT)
	#define	GM_16BIT	(1 << GT_16BIT)
	#define	GM_24BIT	(1 << GT_24BIT)
	#define	GM_32BIT	(1 << GT_32BIT)
	#define	GM_ALL		((1 << GT_LAST) - 1)

	#ifdef GRAPHTYPE_SYMS
          static char *ggi_graph_type[GT_LAST] =
	  {"text", "1bpp", "4bpp", "8bpp", "15bpp", "16bpp", "24bpp", "32bpp"};

	  #define GRAPHTYPE(X) (ggi_graph_type[ X ])
	#endif

	struct ggi_mode		/* requested by user and changed by driver */
	{
	  struct ggi_coord	visible;	/* vis. pixels, not changed   */
          struct ggi_coord	virtual;	/* virt. pixels, may change   */
	  struct ggi_coord	size;		/* size of visible in mm      */
	  enum ggi_graph_type	graphtype;	/* which mode ?		      */
#if 0
	  unsigned short	pages;		/* min. # of graphics pages   */
	  unsigned short	page0y;		/* size of graphics page 0    */
#endif
	  struct ggi_coord	textgrid;	/* fontsize 		      */
	};

#if 0
enum tc_err {	TC_OK=0,TC_NEWTRY,
		TC_LOWERED_CLOCK,TC_LOWEST_CLOCK,
		TC_X_TOO_SMALL  ,TC_Y_TOO_SMALL ,
		TC_X_TOO_BIG    ,TC_Y_TOO_BIG   ,
		TC_LAST_RESORT };
#endif
#endif	/* #ifdef _ggi_h */
