

#include <stdio.h>
#include <fcntl.h>
#include <errno.h>
#include "graphdev.h"

struct ggi_mode
mode = 
{
  { 720, 400 },		/* visible */
  { 720, 400 },		/* virtual */
  {   0,   0 },		/* size    */
  GT_TEXT,
  {   9,  16 }		/* font size */
};

void 
printf_mode(struct ggi_mode *mode)
{
  printf("mode = \n{\n\t{ %i, %i },\t/* visible\t*/\n", mode->visible.x, mode->visible.y);
  printf("\t{ %i, %i },\t/* virtual\t*/\n",mode->virtual.x, mode->virtual.y);
  printf("\t{ %i, %i },\t/* size[mm]\t*/\n",mode->size.x, mode->size.y);
  printf("\t%i,\t\t/* graphtype\t*/\n", mode->graphtype);
  printf("\t{ %i, %i }\t/* textgrid\t*/\n};\n",mode->textgrid.x, mode->textgrid.y);
}

static int ggi_fd = -1;

void ggi_init (void)
{
  if ( (ggi_fd = open (DEVICEFILE_NAME, O_WRONLY)) < 0)
    {				/* mhmm, something went seriously wrong...    */
      perror(NULL);		/* so print the error message and shutdown.   */
      exit(-1);
    }
 				/* file is ok, but is the scrdrv driver?      */
  if (ioctl (ggi_fd, IOC_DRIVER_TESTDRIVER, 0) != DEVICEFILE_MAGIC)
    {
      perror("kgi module magic does not match.\n");
      close(ggi_fd);
      exit(-1);
    }				/* magic numbers fit, thus assume all is ok.  */

  /* !!! lib initialization has to be done ... */
}

void ggi_exit (void)
{
  if (ggi_fd > 0)
    close(ggi_fd);
}

#define ggi_done ggi_exit

#define	IOCTL(C,A)	ioctl(ggi_fd, C, A)

inline int
ggi_testmode (struct ggi_mode *mode)
{					/* test if mode is possible */
  return IOCTL(IOC_DRIVER_TESTMODE, mode);
}

inline int
ggi_set_graphmode (struct ggi_mode *mode)
{					/* set graphics mode, no mode switch */
  return IOCTL(IOC_DRIVER_SETGRAPHMODE, mode);
}

inline int
ggi_get_graphmode (struct ggi_mode *mode)
{					/* get graphics mode		     */
  return IOCTL(IOC_DRIVER_GETGRAPHMODE, mode);
}

inline int
ggi_graphics (void)
{					/* switch to graphic mode	     */
  return ioctl(ggi_fd, IOC_DRIVER_GRAPHICS, 0);
}

inline int
ggi_set_textmode (struct ggi_mode *mode)
{					/* set text mode, no mode switch     */
  return IOCTL(IOC_DRIVER_SETTEXTMODE, mode);
}

inline int
ggi_get_textmode (struct ggi_mode *mode)
{					/* get text mode		     */
  return IOCTL(IOC_DRIVER_GETTEXTMODE, mode);
}

inlint int
ggi_text (void)
{
  return IOCTL(IOC_DRIVER_TEXT, 0);
}

main()
{
  ggi_init ();

  if (ggi_testmode(&mode))
    {
      printf ("mode not ok.\n");
    }

  printf_mode (&mode);
  ggi_done ();
}

